<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<app-selection
  [items]="filteredItems"
  [loading]="(initializing$ | async) ?? false"
  [error]="errorInitializing$ | async"
  [selectable]="false"
  [search]="search"
  [defaultPicked]="defaultPicked"
  (onChange)="onChange($event)"
>
  <ng-template #preview let-item>
    <app-item-preview [item]="item"></app-item-preview>
  </ng-template>
  <ng-template #leading>
    <app-filter-items [filter]="filter" (onFilterChange)="onFilterChange($event)"></app-filter-items>
  </ng-template>
  <ng-template *ngIf="filteredItems.length > 0" #action>
    <p-button
      label="Re-run discovery"
      [outlined]="true"
      icon="pi pi-sync"
      size="small"
      (click)="onTryAgain()"
    ></p-button>
  </ng-template>
  <ng-template #detail let-item>
    <router-outlet *ngIf="item"></router-outlet>
    <div *ngIf="!item" class="w-full h-full">
      <div class="w-full h-full flex items-center justify-center bg-secondary-50 text-text-300 rounded-sm text-base">
        No item selected
      </div>
    </div>
  </ng-template>
  <ng-template #onError let-error>
    <div class="w-full flex flex-col items-center gap-12 mt-24">
      <div class="text-lg font-semibold text-text-300">
        <app-sad-face></app-sad-face>
      </div>
      <div class="flex flex-col gap-4 items-center">
        <p-message severity="warning" text="Failed to load My Node items"></p-message>
        <p-button label="Try Again" [outlined]="true" size="small" (click)="onTryAgain()"></p-button>
      </div>
    </div>
  </ng-template>
  <ng-template #onEmpty>
    <div class="w-full flex flex-col items-center gap-4 mt-8">
      <div class="text-lg font-semibold text-text-300">
        <app-sad-face></app-sad-face>
      </div>
      <div class="text-text-300">No items</div>
      <p-button
        label="Re-run discovery"
        [outlined]="true"
        size="small"
        icon="pi pi-sync"
        (click)="onTryAgain()"
      ></p-button>
    </div>
  </ng-template>
</app-selection>
